import { Component, Vue, Prop, Emit } from "vue-facing-decorator";
// import { Prop, Emit } from "vue-property-decorator";

@Component({
    name: "ActiveFacetCategory",
})
export default class ActiveFacetCategory extends Vue {
    bar = "";

    @Prop({
        type: Array<string>,
    })
    filterItems!: string[];

    @Prop({
        type: String,
        required: true,
    })
    categoryName!: string;

    // @Prop([String])
    // alias;

    /**
     * The alias for the Active facet box will be set depending on the name of the category. 
     * This will allow to display the customised terms "creator" and "keyword" instead of the values currently used in the OpenSearch index: "author" and "subjects"
     * TODO: This should be corrected directly in the index
     */
    get alias(): string {
        // return this.categoryName == "doctype" ? "datatype" : this.categoryName;
        // console.log("getAlias!");
        switch (this.categoryName) {
            case "author":
                return "creator";
            case "subjects":
                return "keyword";
            case "doctype":
                    return "datatype";
            default:
                return this.categoryName;
        }
    }

    // get filterItems(): Array<string> {
    //     return this.data;
    // }

    // get uncollapseLabelText() : string {
    //     if (this.collapsed == true) {
    //         // return myLabels.viewer.sidePanel.more; //"More results";
    //         return "More results";
    //     }
    //     else {
    //         // return myLabels.viewer.sidePanel.collapse; //"Collapse";
    //         return "Collapse";
    //     }
    // }

    // toggle = function (): void {
    //     if (this.collapsed == true) {
    //         this.collapsed = false;
    //     }
    //     else if (this.collapsed == false) {
    //         this.collapsed = true;
    //         //list.children("li:gt(4)").hide();
    //     }
    // }

    @Emit("clear-facet-category")
    deactivateFacetCategory(): string {
        // filterItem.Category = this.alias;
        // filterItem.Active = true;
        // this.$emit("clearFacetCategory", this.categoryName, this.alias);
        return this.categoryName;
    }
}
